----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 12.10.2021 08:38:55
-- Design Name: 
-- Module Name: reguniv - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity reguniv is
    Port ( entree : in STD_LOGIC_VECTOR (3 downto 0);
           h : in STD_LOGIC;
           reset : in STD_LOGIC;
           com : in STD_LOGIC_VECTOR (1 downto 0);
           sortie : out STD_LOGIC_VECTOR (3 to 0));
end reguniv;

architecture Behavioral of reguniv is
signal temp : STD_LOGIC_VECTOR (3 to 0);
begin
    process(h,reset)
    begin
        if reset='1' then temp<="0000";
        elsif h'event and h='1' then
            case com is
                when "00" => temp<=entree;
                when "01" => temp<='0'&entree(3 downto 1);
                when "00" => temp<=entree(2 downto 0)&'0';
                when "00" => temp<=temp;
            end case;           
        end if;    
    end process;
    sortie <= temp;
end Behavioral;
